



%% -----------EX 1 ----------- 
 x = rand(1, 10); % suppose 10 samples of a random signal 
 y = fft(x); % Fourier transform of the signal 
 iy = ifft(y); % inverse Fourier transform 
 x2 = real(iy); % discard imaginary part
 norm(x) % compare original with inverse of transformed 
 norm(x2)



  
 
 
 
 
 
 
%% ----------- EX2 ----------- 

 clear all
 close all
 dt = 1/100; % sampling rate (period)
 et = 4; % end of the interval 
 t = 0 : dt : et; % sampling range 
 y = 3 *sin(4*2*pi*t) + 5*sin(2*2*pi*t); % sample the signal 
 subplot(2, 1, 1); % first of two plots 
 plot(t, y); grid on % plot with grid 
 axis([0 et -8 8]); % adjust scaling 
 xlabel('Time (s)'); % time expressed in seconds 
 ylabel('Amplitude'); % amplitude as function of time  

Nsamps = length(y); 
Y = abs(fft(y)); % compute Fourier transform. Retain magnitude!
Y=Y(1:Nsamps/2); %discard half of the points. Second half are complex conjugates 
Y=Y/size(Y,2);  %Normalization
f=1/dt*(0:Nsamps/2-1)/Nsamps; % Create frequency vector for plotting

subplot(2, 1, 2); % second of two plots  
plot(f, Y); grid on % plot amplitude spectrum  
xlim([0 20]) %adjust X scale for better visualization
xlabel('Frequency (Hz)'); % 1 Herz = number of cycles per second 
ylabel('Amplitude'); % amplitude as function of frequency 







%% ----------- EX3 ----------- 

noise = randn(1, size(y, 2)); % random noise  
ey = y + noise; % samples with noise  
eY = abs(fft(ey)); % compute Fourier transform of noisy signal. Retain magnitude!
eY=eY(1:Nsamps/2); %discard half of the points. Second half are complex conjugates 
eY=eY/size(eY,2);  %Normalization
f=1/dt*(0:Nsamps/2-1)/Nsamps; % Create frequency vector for plotting

figure % plots in new window  
subplot(2, 1, 1); % First of two plots  
plot(t, ey); grid on % plot noisy signal with grid  
axis([0 et -8 8]); % scale axes for viewing  
xlabel('Time (s)'); % time expressed in seconds  
ylabel('Amplitude'); % amplitude as function of time  
subplot(2, 1, 2); % second of two plots 
plot(f, eY); grid on % plot amplitude spectrum  
xlim([0 20]) %
xlabel('Frequency (Hz)'); % 1 Herz = number of cycles per second 
ylabel('Amplitude'); % amplitude as function of frequency 







%  Inverse FFT

eY = fft(ey); % compute again the Fourier transform of noisy signal, without abs
fY = fix(eY/100)*100; % set numbers < 100 to zero 
ifY = ifft(fY); % inverse Fourier transform of fixed data 
cy = real(ifY); % remove imaginary parts 

 figure % new window for plot 
 plot(t, cy); grid on % plot corrected signal  

axis([0 et -8 8]); % adjust scale for viewing 
xlabel('Time (s)'); % time expressed in seconds  
ylabel('Amplitude'); % amplitude as function of time








%% ---------- EX 4 ----------- 

n  =  [0:29];
x  =  cos(2*pi*n/10);

N1  =  30;
N2  =  128;
N3  =  256;
X1  =  abs(fft(x,N1));
X2  =  abs(fft(x,N2));
X3  =  abs(fft(x,N3));

F1  =  [0  :    N1  -  1]/N1;
F2  =  [0  :    N2  -  1]/N2;
F3  =  [0  :    N3  -  1]/N3;

subplot(3,1,1)
plot(F1,X1,'-x'),title('N  =  64'),axis([0  1  0  20])
subplot(3,1,2)
plot(F2,X2,'-x'),title('N  =  128'),axis([0  1  0  20])
subplot(3,1,3)
plot(F3,X3,'-x'),title('N  =  256'),axis([0  1  0  20])









%% ---------- EX 5 ----------- 



f=zeros(30,30); f(5:24,13:17)=1; 
imshow(f,'InitialMagnification','fit') %Rectangle
F=fft2(f); F2=abs(F); 
figure, imshow(F2,[],'InitialMagnification','fit') %2D DFT of the rectangle
F=fft2(f, 256,256); F2=abs(F); figure, imshow(F2, [])
F2=fftshift(F); F2=abs(F2); figure,imshow(F2,[])
F2=log(1+F2); figure,imshow(F2,[])  




